/*
 * Data API
 *
 * Cognitive Credit Company Data API
 *
 * The version of the OpenAPI document: 1.0.0
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Net.Mime;
using Org.OpenAPITools.Client;
using Org.OpenAPITools.Model;

namespace Org.OpenAPITools.Api
{

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IDefaultApiSync : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Get company comparables
        /// </summary>
        /// <remarks>
        /// Returns comparables data for a list of companies for the allowed coverage_universe
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="interval">identifier for the interval of comparables data to fetch</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return comparables snapshot for (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ComparablesResponse</returns>
        ComparablesResponse ApiConsumerProjectLocalGetCompanyComparablesSubtypes(string interval, DateTime? atTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0);

        /// <summary>
        /// Get company comparables
        /// </summary>
        /// <remarks>
        /// Returns comparables data for a list of companies for the allowed coverage_universe
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="interval">identifier for the interval of comparables data to fetch</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return comparables snapshot for (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of ComparablesResponse</returns>
        ApiResponse<ComparablesResponse> ApiConsumerProjectLocalGetCompanyComparablesSubtypesWithHttpInfo(string interval, DateTime? atTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0);
        /// <summary>
        /// Get a company datapoint
        /// </summary>
        /// <remarks>
        /// Returns details of an individual datapoint for a company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="datapointId">identifier for the datapoint</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>CompanyDatapointResponse</returns>
        CompanyDatapointResponse ApiConsumerProjectLocalGetCompanyDatapoint(string datapointId, string acceptEncoding = default(string), int operationIndex = 0);

        /// <summary>
        /// Get a company datapoint
        /// </summary>
        /// <remarks>
        /// Returns details of an individual datapoint for a company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="datapointId">identifier for the datapoint</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of CompanyDatapointResponse</returns>
        ApiResponse<CompanyDatapointResponse> ApiConsumerProjectLocalGetCompanyDatapointWithHttpInfo(string datapointId, string acceptEncoding = default(string), int operationIndex = 0);
        /// <summary>
        /// Get company financials
        /// </summary>
        /// <remarks>
        /// Returns historical financials data for single company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return financials snapshot for (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>CompanyFinancialsResponse</returns>
        CompanyFinancialsResponse ApiConsumerProjectLocalGetCompanyFinancials(string companyId, DateTime? atTimestamp = default(DateTime?), string acceptEncoding = default(string), int operationIndex = 0);

        /// <summary>
        /// Get company financials
        /// </summary>
        /// <remarks>
        /// Returns historical financials data for single company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return financials snapshot for (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of CompanyFinancialsResponse</returns>
        ApiResponse<CompanyFinancialsResponse> ApiConsumerProjectLocalGetCompanyFinancialsWithHttpInfo(string companyId, DateTime? atTimestamp = default(DateTime?), string acceptEncoding = default(string), int operationIndex = 0);
        /// <summary>
        /// Get company descriptions
        /// </summary>
        /// <remarks>
        /// Returns a list of company description objects.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return companies snapshot for (optional)</param>
        /// <param name="isRetired">filter by &#39;retired&#39; status - (true|false) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids - comma separated list (optional)</param>
        /// <param name="tickers">filter by supplied company tickers (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="updatedAfter">Only return company descriptions added or updated on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="updatedBefore">Only return company descriptions added or updated before this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateAfter">Only return company descriptions for companies with reports on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateBefore">Only return company descriptions for companies with reports before this ISO-8601 timestamp (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>CompanyDescriptionResponse</returns>
        CompanyDescriptionResponse ApiConsumerProjectLocalGetCompanyListings(DateTime? atTimestamp = default(DateTime?), string isRetired = default(string), string companyIds = default(string), string tickers = default(string), int? limit = default(int?), DateTime? updatedAfter = default(DateTime?), DateTime? updatedBefore = default(DateTime?), DateTime? lastReportedDateAfter = default(DateTime?), DateTime? lastReportedDateBefore = default(DateTime?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0);

        /// <summary>
        /// Get company descriptions
        /// </summary>
        /// <remarks>
        /// Returns a list of company description objects.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return companies snapshot for (optional)</param>
        /// <param name="isRetired">filter by &#39;retired&#39; status - (true|false) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids - comma separated list (optional)</param>
        /// <param name="tickers">filter by supplied company tickers (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="updatedAfter">Only return company descriptions added or updated on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="updatedBefore">Only return company descriptions added or updated before this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateAfter">Only return company descriptions for companies with reports on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateBefore">Only return company descriptions for companies with reports before this ISO-8601 timestamp (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of CompanyDescriptionResponse</returns>
        ApiResponse<CompanyDescriptionResponse> ApiConsumerProjectLocalGetCompanyListingsWithHttpInfo(DateTime? atTimestamp = default(DateTime?), string isRetired = default(string), string companyIds = default(string), string tickers = default(string), int? limit = default(int?), DateTime? updatedAfter = default(DateTime?), DateTime? updatedBefore = default(DateTime?), DateTime? lastReportedDateAfter = default(DateTime?), DateTime? lastReportedDateBefore = default(DateTime?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0);
        /// <summary>
        /// Get company time series
        /// </summary>
        /// <remarks>
        /// Returns all historical values of a specific comparable for a given company and interval
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch time series data for</param>
        /// <param name="tag">identifier for the comparable tag to fetch time series data for</param>
        /// <param name="interval">identifier for the interval to fetch time series data for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>CompanyTimeSeriesResponse</returns>
        CompanyTimeSeriesResponse ApiConsumerProjectLocalGetCompanyTimeSeries(string companyId, string tag, string interval, string acceptEncoding = default(string), int operationIndex = 0);

        /// <summary>
        /// Get company time series
        /// </summary>
        /// <remarks>
        /// Returns all historical values of a specific comparable for a given company and interval
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch time series data for</param>
        /// <param name="tag">identifier for the comparable tag to fetch time series data for</param>
        /// <param name="interval">identifier for the interval to fetch time series data for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of CompanyTimeSeriesResponse</returns>
        ApiResponse<CompanyTimeSeriesResponse> ApiConsumerProjectLocalGetCompanyTimeSeriesWithHttpInfo(string companyId, string tag, string interval, string acceptEncoding = default(string), int operationIndex = 0);
        /// <summary>
        /// Get company comparables updates for a given time period
        /// </summary>
        /// <remarks>
        /// Returns comparables data for a list of companies for the allowed coverage_universe, from a given start timestamp and optional end timestamp
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="startTimestamp">ISO-8601 Timestamp to return comparables updates since (all updates greater than or equal to the timestamp) (optional)</param>
        /// <param name="endTimestamp">ISO-8601 Timestamp to return comparables updates until (all updates less than, but not equal to, the timestamp) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ComparablesResponse</returns>
        ComparablesResponse ApiConsumerProjectLocalGetComparablesUpdatesSince(DateTime? startTimestamp = default(DateTime?), DateTime? endTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0);

        /// <summary>
        /// Get company comparables updates for a given time period
        /// </summary>
        /// <remarks>
        /// Returns comparables data for a list of companies for the allowed coverage_universe, from a given start timestamp and optional end timestamp
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="startTimestamp">ISO-8601 Timestamp to return comparables updates since (all updates greater than or equal to the timestamp) (optional)</param>
        /// <param name="endTimestamp">ISO-8601 Timestamp to return comparables updates until (all updates less than, but not equal to, the timestamp) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of ComparablesResponse</returns>
        ApiResponse<ComparablesResponse> ApiConsumerProjectLocalGetComparablesUpdatesSinceWithHttpInfo(DateTime? startTimestamp = default(DateTime?), DateTime? endTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0);
        /// <summary>
        /// Get company period dates
        /// </summary>
        /// <remarks>
        /// Returns end dates of financial reporting periods for given company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>CompanyPeriodDatesResponse</returns>
        CompanyPeriodDatesResponse ApiConsumerProjectLocalGetPeriodDates(string companyId, string acceptEncoding = default(string), int operationIndex = 0);

        /// <summary>
        /// Get company period dates
        /// </summary>
        /// <remarks>
        /// Returns end dates of financial reporting periods for given company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of CompanyPeriodDatesResponse</returns>
        ApiResponse<CompanyPeriodDatesResponse> ApiConsumerProjectLocalGetPeriodDatesWithHttpInfo(string companyId, string acceptEncoding = default(string), int operationIndex = 0);
        #endregion Synchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IDefaultApiAsync : IApiAccessor
    {
        #region Asynchronous Operations
        /// <summary>
        /// Get company comparables
        /// </summary>
        /// <remarks>
        /// Returns comparables data for a list of companies for the allowed coverage_universe
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="interval">identifier for the interval of comparables data to fetch</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return comparables snapshot for (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ComparablesResponse</returns>
        System.Threading.Tasks.Task<ComparablesResponse> ApiConsumerProjectLocalGetCompanyComparablesSubtypesAsync(string interval, DateTime? atTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Get company comparables
        /// </summary>
        /// <remarks>
        /// Returns comparables data for a list of companies for the allowed coverage_universe
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="interval">identifier for the interval of comparables data to fetch</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return comparables snapshot for (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (ComparablesResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<ComparablesResponse>> ApiConsumerProjectLocalGetCompanyComparablesSubtypesWithHttpInfoAsync(string interval, DateTime? atTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// Get a company datapoint
        /// </summary>
        /// <remarks>
        /// Returns details of an individual datapoint for a company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="datapointId">identifier for the datapoint</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of CompanyDatapointResponse</returns>
        System.Threading.Tasks.Task<CompanyDatapointResponse> ApiConsumerProjectLocalGetCompanyDatapointAsync(string datapointId, string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Get a company datapoint
        /// </summary>
        /// <remarks>
        /// Returns details of an individual datapoint for a company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="datapointId">identifier for the datapoint</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (CompanyDatapointResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<CompanyDatapointResponse>> ApiConsumerProjectLocalGetCompanyDatapointWithHttpInfoAsync(string datapointId, string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// Get company financials
        /// </summary>
        /// <remarks>
        /// Returns historical financials data for single company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return financials snapshot for (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of CompanyFinancialsResponse</returns>
        System.Threading.Tasks.Task<CompanyFinancialsResponse> ApiConsumerProjectLocalGetCompanyFinancialsAsync(string companyId, DateTime? atTimestamp = default(DateTime?), string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Get company financials
        /// </summary>
        /// <remarks>
        /// Returns historical financials data for single company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return financials snapshot for (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (CompanyFinancialsResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<CompanyFinancialsResponse>> ApiConsumerProjectLocalGetCompanyFinancialsWithHttpInfoAsync(string companyId, DateTime? atTimestamp = default(DateTime?), string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// Get company descriptions
        /// </summary>
        /// <remarks>
        /// Returns a list of company description objects.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return companies snapshot for (optional)</param>
        /// <param name="isRetired">filter by &#39;retired&#39; status - (true|false) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids - comma separated list (optional)</param>
        /// <param name="tickers">filter by supplied company tickers (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="updatedAfter">Only return company descriptions added or updated on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="updatedBefore">Only return company descriptions added or updated before this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateAfter">Only return company descriptions for companies with reports on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateBefore">Only return company descriptions for companies with reports before this ISO-8601 timestamp (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of CompanyDescriptionResponse</returns>
        System.Threading.Tasks.Task<CompanyDescriptionResponse> ApiConsumerProjectLocalGetCompanyListingsAsync(DateTime? atTimestamp = default(DateTime?), string isRetired = default(string), string companyIds = default(string), string tickers = default(string), int? limit = default(int?), DateTime? updatedAfter = default(DateTime?), DateTime? updatedBefore = default(DateTime?), DateTime? lastReportedDateAfter = default(DateTime?), DateTime? lastReportedDateBefore = default(DateTime?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Get company descriptions
        /// </summary>
        /// <remarks>
        /// Returns a list of company description objects.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return companies snapshot for (optional)</param>
        /// <param name="isRetired">filter by &#39;retired&#39; status - (true|false) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids - comma separated list (optional)</param>
        /// <param name="tickers">filter by supplied company tickers (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="updatedAfter">Only return company descriptions added or updated on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="updatedBefore">Only return company descriptions added or updated before this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateAfter">Only return company descriptions for companies with reports on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateBefore">Only return company descriptions for companies with reports before this ISO-8601 timestamp (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (CompanyDescriptionResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<CompanyDescriptionResponse>> ApiConsumerProjectLocalGetCompanyListingsWithHttpInfoAsync(DateTime? atTimestamp = default(DateTime?), string isRetired = default(string), string companyIds = default(string), string tickers = default(string), int? limit = default(int?), DateTime? updatedAfter = default(DateTime?), DateTime? updatedBefore = default(DateTime?), DateTime? lastReportedDateAfter = default(DateTime?), DateTime? lastReportedDateBefore = default(DateTime?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// Get company time series
        /// </summary>
        /// <remarks>
        /// Returns all historical values of a specific comparable for a given company and interval
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch time series data for</param>
        /// <param name="tag">identifier for the comparable tag to fetch time series data for</param>
        /// <param name="interval">identifier for the interval to fetch time series data for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of CompanyTimeSeriesResponse</returns>
        System.Threading.Tasks.Task<CompanyTimeSeriesResponse> ApiConsumerProjectLocalGetCompanyTimeSeriesAsync(string companyId, string tag, string interval, string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Get company time series
        /// </summary>
        /// <remarks>
        /// Returns all historical values of a specific comparable for a given company and interval
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch time series data for</param>
        /// <param name="tag">identifier for the comparable tag to fetch time series data for</param>
        /// <param name="interval">identifier for the interval to fetch time series data for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (CompanyTimeSeriesResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<CompanyTimeSeriesResponse>> ApiConsumerProjectLocalGetCompanyTimeSeriesWithHttpInfoAsync(string companyId, string tag, string interval, string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// Get company comparables updates for a given time period
        /// </summary>
        /// <remarks>
        /// Returns comparables data for a list of companies for the allowed coverage_universe, from a given start timestamp and optional end timestamp
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="startTimestamp">ISO-8601 Timestamp to return comparables updates since (all updates greater than or equal to the timestamp) (optional)</param>
        /// <param name="endTimestamp">ISO-8601 Timestamp to return comparables updates until (all updates less than, but not equal to, the timestamp) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ComparablesResponse</returns>
        System.Threading.Tasks.Task<ComparablesResponse> ApiConsumerProjectLocalGetComparablesUpdatesSinceAsync(DateTime? startTimestamp = default(DateTime?), DateTime? endTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Get company comparables updates for a given time period
        /// </summary>
        /// <remarks>
        /// Returns comparables data for a list of companies for the allowed coverage_universe, from a given start timestamp and optional end timestamp
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="startTimestamp">ISO-8601 Timestamp to return comparables updates since (all updates greater than or equal to the timestamp) (optional)</param>
        /// <param name="endTimestamp">ISO-8601 Timestamp to return comparables updates until (all updates less than, but not equal to, the timestamp) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (ComparablesResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<ComparablesResponse>> ApiConsumerProjectLocalGetComparablesUpdatesSinceWithHttpInfoAsync(DateTime? startTimestamp = default(DateTime?), DateTime? endTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// Get company period dates
        /// </summary>
        /// <remarks>
        /// Returns end dates of financial reporting periods for given company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of CompanyPeriodDatesResponse</returns>
        System.Threading.Tasks.Task<CompanyPeriodDatesResponse> ApiConsumerProjectLocalGetPeriodDatesAsync(string companyId, string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Get company period dates
        /// </summary>
        /// <remarks>
        /// Returns end dates of financial reporting periods for given company
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (CompanyPeriodDatesResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<CompanyPeriodDatesResponse>> ApiConsumerProjectLocalGetPeriodDatesWithHttpInfoAsync(string companyId, string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IDefaultApi : IDefaultApiSync, IDefaultApiAsync
    {

    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class DefaultApi : IDefaultApi
    {
        private Org.OpenAPITools.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="DefaultApi"/> class.
        /// </summary>
        /// <returns></returns>
        public DefaultApi() : this((string)null)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DefaultApi"/> class.
        /// </summary>
        /// <returns></returns>
        public DefaultApi(string basePath)
        {
            this.Configuration = Org.OpenAPITools.Client.Configuration.MergeConfigurations(
                Org.OpenAPITools.Client.GlobalConfiguration.Instance,
                new Org.OpenAPITools.Client.Configuration { BasePath = basePath }
            );
            this.Client = new Org.OpenAPITools.Client.ApiClient(this.Configuration.BasePath);
            this.AsynchronousClient = new Org.OpenAPITools.Client.ApiClient(this.Configuration.BasePath);
            this.ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DefaultApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public DefaultApi(Org.OpenAPITools.Client.Configuration configuration)
        {
            if (configuration == null) throw new ArgumentNullException("configuration");

            this.Configuration = Org.OpenAPITools.Client.Configuration.MergeConfigurations(
                Org.OpenAPITools.Client.GlobalConfiguration.Instance,
                configuration
            );
            this.Client = new Org.OpenAPITools.Client.ApiClient(this.Configuration.BasePath);
            this.AsynchronousClient = new Org.OpenAPITools.Client.ApiClient(this.Configuration.BasePath);
            ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DefaultApi"/> class
        /// using a Configuration object and client instance.
        /// </summary>
        /// <param name="client">The client interface for synchronous API access.</param>
        /// <param name="asyncClient">The client interface for asynchronous API access.</param>
        /// <param name="configuration">The configuration object.</param>
        public DefaultApi(Org.OpenAPITools.Client.ISynchronousClient client, Org.OpenAPITools.Client.IAsynchronousClient asyncClient, Org.OpenAPITools.Client.IReadableConfiguration configuration)
        {
            if (client == null) throw new ArgumentNullException("client");
            if (asyncClient == null) throw new ArgumentNullException("asyncClient");
            if (configuration == null) throw new ArgumentNullException("configuration");

            this.Client = client;
            this.AsynchronousClient = asyncClient;
            this.Configuration = configuration;
            this.ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// The client for accessing this underlying API asynchronously.
        /// </summary>
        public Org.OpenAPITools.Client.IAsynchronousClient AsynchronousClient { get; set; }

        /// <summary>
        /// The client for accessing this underlying API synchronously.
        /// </summary>
        public Org.OpenAPITools.Client.ISynchronousClient Client { get; set; }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public string GetBasePath()
        {
            return this.Configuration.BasePath;
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Org.OpenAPITools.Client.IReadableConfiguration Configuration { get; set; }

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public Org.OpenAPITools.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Get company comparables Returns comparables data for a list of companies for the allowed coverage_universe
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="interval">identifier for the interval of comparables data to fetch</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return comparables snapshot for (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ComparablesResponse</returns>
        public ComparablesResponse ApiConsumerProjectLocalGetCompanyComparablesSubtypes(string interval, DateTime? atTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0)
        {
            Org.OpenAPITools.Client.ApiResponse<ComparablesResponse> localVarResponse = ApiConsumerProjectLocalGetCompanyComparablesSubtypesWithHttpInfo(interval, atTimestamp, companyIds, limit, continuationToken, acceptEncoding);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Get company comparables Returns comparables data for a list of companies for the allowed coverage_universe
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="interval">identifier for the interval of comparables data to fetch</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return comparables snapshot for (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of ComparablesResponse</returns>
        public Org.OpenAPITools.Client.ApiResponse<ComparablesResponse> ApiConsumerProjectLocalGetCompanyComparablesSubtypesWithHttpInfo(string interval, DateTime? atTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0)
        {
            // verify the required parameter 'interval' is set
            if (interval == null)
            {
                throw new Org.OpenAPITools.Client.ApiException(400, "Missing required parameter 'interval' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyComparablesSubtypes");
            }

            Org.OpenAPITools.Client.RequestOptions localVarRequestOptions = new Org.OpenAPITools.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = Org.OpenAPITools.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Org.OpenAPITools.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("interval", Org.OpenAPITools.Client.ClientUtils.ParameterToString(interval)); // path parameter
            if (atTimestamp != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "at_timestamp", atTimestamp));
            }
            if (companyIds != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "company_ids", companyIds));
            }
            if (limit != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "limit", limit));
            }
            if (continuationToken != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "continuation_token", continuationToken));
            }
            if (acceptEncoding != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept-Encoding", Org.OpenAPITools.Client.ClientUtils.ParameterToString(acceptEncoding)); // header parameter
            }

            localVarRequestOptions.Operation = "DefaultApi.ApiConsumerProjectLocalGetCompanyComparablesSubtypes";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (authorizeClient) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<ComparablesResponse>("/comparables/{interval}", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("ApiConsumerProjectLocalGetCompanyComparablesSubtypes", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Get company comparables Returns comparables data for a list of companies for the allowed coverage_universe
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="interval">identifier for the interval of comparables data to fetch</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return comparables snapshot for (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ComparablesResponse</returns>
        public async System.Threading.Tasks.Task<ComparablesResponse> ApiConsumerProjectLocalGetCompanyComparablesSubtypesAsync(string interval, DateTime? atTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            Org.OpenAPITools.Client.ApiResponse<ComparablesResponse> localVarResponse = await ApiConsumerProjectLocalGetCompanyComparablesSubtypesWithHttpInfoAsync(interval, atTimestamp, companyIds, limit, continuationToken, acceptEncoding, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Get company comparables Returns comparables data for a list of companies for the allowed coverage_universe
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="interval">identifier for the interval of comparables data to fetch</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return comparables snapshot for (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (ComparablesResponse)</returns>
        public async System.Threading.Tasks.Task<Org.OpenAPITools.Client.ApiResponse<ComparablesResponse>> ApiConsumerProjectLocalGetCompanyComparablesSubtypesWithHttpInfoAsync(string interval, DateTime? atTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            // verify the required parameter 'interval' is set
            if (interval == null)
            {
                throw new Org.OpenAPITools.Client.ApiException(400, "Missing required parameter 'interval' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyComparablesSubtypes");
            }


            Org.OpenAPITools.Client.RequestOptions localVarRequestOptions = new Org.OpenAPITools.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = Org.OpenAPITools.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Org.OpenAPITools.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("interval", Org.OpenAPITools.Client.ClientUtils.ParameterToString(interval)); // path parameter
            if (atTimestamp != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "at_timestamp", atTimestamp));
            }
            if (companyIds != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "company_ids", companyIds));
            }
            if (limit != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "limit", limit));
            }
            if (continuationToken != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "continuation_token", continuationToken));
            }
            if (acceptEncoding != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept-Encoding", Org.OpenAPITools.Client.ClientUtils.ParameterToString(acceptEncoding)); // header parameter
            }

            localVarRequestOptions.Operation = "DefaultApi.ApiConsumerProjectLocalGetCompanyComparablesSubtypes";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (authorizeClient) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<ComparablesResponse>("/comparables/{interval}", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("ApiConsumerProjectLocalGetCompanyComparablesSubtypes", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Get a company datapoint Returns details of an individual datapoint for a company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="datapointId">identifier for the datapoint</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>CompanyDatapointResponse</returns>
        public CompanyDatapointResponse ApiConsumerProjectLocalGetCompanyDatapoint(string datapointId, string acceptEncoding = default(string), int operationIndex = 0)
        {
            Org.OpenAPITools.Client.ApiResponse<CompanyDatapointResponse> localVarResponse = ApiConsumerProjectLocalGetCompanyDatapointWithHttpInfo(datapointId, acceptEncoding);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Get a company datapoint Returns details of an individual datapoint for a company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="datapointId">identifier for the datapoint</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of CompanyDatapointResponse</returns>
        public Org.OpenAPITools.Client.ApiResponse<CompanyDatapointResponse> ApiConsumerProjectLocalGetCompanyDatapointWithHttpInfo(string datapointId, string acceptEncoding = default(string), int operationIndex = 0)
        {
            // verify the required parameter 'datapointId' is set
            if (datapointId == null)
            {
                throw new Org.OpenAPITools.Client.ApiException(400, "Missing required parameter 'datapointId' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyDatapoint");
            }

            Org.OpenAPITools.Client.RequestOptions localVarRequestOptions = new Org.OpenAPITools.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = Org.OpenAPITools.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Org.OpenAPITools.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("datapointId", Org.OpenAPITools.Client.ClientUtils.ParameterToString(datapointId)); // path parameter
            if (acceptEncoding != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept-Encoding", Org.OpenAPITools.Client.ClientUtils.ParameterToString(acceptEncoding)); // header parameter
            }

            localVarRequestOptions.Operation = "DefaultApi.ApiConsumerProjectLocalGetCompanyDatapoint";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (authorizeClient) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<CompanyDatapointResponse>("/datapoints/{datapointId}", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("ApiConsumerProjectLocalGetCompanyDatapoint", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Get a company datapoint Returns details of an individual datapoint for a company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="datapointId">identifier for the datapoint</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of CompanyDatapointResponse</returns>
        public async System.Threading.Tasks.Task<CompanyDatapointResponse> ApiConsumerProjectLocalGetCompanyDatapointAsync(string datapointId, string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            Org.OpenAPITools.Client.ApiResponse<CompanyDatapointResponse> localVarResponse = await ApiConsumerProjectLocalGetCompanyDatapointWithHttpInfoAsync(datapointId, acceptEncoding, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Get a company datapoint Returns details of an individual datapoint for a company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="datapointId">identifier for the datapoint</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (CompanyDatapointResponse)</returns>
        public async System.Threading.Tasks.Task<Org.OpenAPITools.Client.ApiResponse<CompanyDatapointResponse>> ApiConsumerProjectLocalGetCompanyDatapointWithHttpInfoAsync(string datapointId, string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            // verify the required parameter 'datapointId' is set
            if (datapointId == null)
            {
                throw new Org.OpenAPITools.Client.ApiException(400, "Missing required parameter 'datapointId' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyDatapoint");
            }


            Org.OpenAPITools.Client.RequestOptions localVarRequestOptions = new Org.OpenAPITools.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = Org.OpenAPITools.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Org.OpenAPITools.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("datapointId", Org.OpenAPITools.Client.ClientUtils.ParameterToString(datapointId)); // path parameter
            if (acceptEncoding != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept-Encoding", Org.OpenAPITools.Client.ClientUtils.ParameterToString(acceptEncoding)); // header parameter
            }

            localVarRequestOptions.Operation = "DefaultApi.ApiConsumerProjectLocalGetCompanyDatapoint";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (authorizeClient) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<CompanyDatapointResponse>("/datapoints/{datapointId}", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("ApiConsumerProjectLocalGetCompanyDatapoint", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Get company financials Returns historical financials data for single company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return financials snapshot for (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>CompanyFinancialsResponse</returns>
        public CompanyFinancialsResponse ApiConsumerProjectLocalGetCompanyFinancials(string companyId, DateTime? atTimestamp = default(DateTime?), string acceptEncoding = default(string), int operationIndex = 0)
        {
            Org.OpenAPITools.Client.ApiResponse<CompanyFinancialsResponse> localVarResponse = ApiConsumerProjectLocalGetCompanyFinancialsWithHttpInfo(companyId, atTimestamp, acceptEncoding);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Get company financials Returns historical financials data for single company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return financials snapshot for (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of CompanyFinancialsResponse</returns>
        public Org.OpenAPITools.Client.ApiResponse<CompanyFinancialsResponse> ApiConsumerProjectLocalGetCompanyFinancialsWithHttpInfo(string companyId, DateTime? atTimestamp = default(DateTime?), string acceptEncoding = default(string), int operationIndex = 0)
        {
            // verify the required parameter 'companyId' is set
            if (companyId == null)
            {
                throw new Org.OpenAPITools.Client.ApiException(400, "Missing required parameter 'companyId' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyFinancials");
            }

            Org.OpenAPITools.Client.RequestOptions localVarRequestOptions = new Org.OpenAPITools.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = Org.OpenAPITools.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Org.OpenAPITools.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("companyId", Org.OpenAPITools.Client.ClientUtils.ParameterToString(companyId)); // path parameter
            if (atTimestamp != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "at_timestamp", atTimestamp));
            }
            if (acceptEncoding != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept-Encoding", Org.OpenAPITools.Client.ClientUtils.ParameterToString(acceptEncoding)); // header parameter
            }

            localVarRequestOptions.Operation = "DefaultApi.ApiConsumerProjectLocalGetCompanyFinancials";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (authorizeClient) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<CompanyFinancialsResponse>("/companies/{companyId}/financials", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("ApiConsumerProjectLocalGetCompanyFinancials", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Get company financials Returns historical financials data for single company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return financials snapshot for (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of CompanyFinancialsResponse</returns>
        public async System.Threading.Tasks.Task<CompanyFinancialsResponse> ApiConsumerProjectLocalGetCompanyFinancialsAsync(string companyId, DateTime? atTimestamp = default(DateTime?), string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            Org.OpenAPITools.Client.ApiResponse<CompanyFinancialsResponse> localVarResponse = await ApiConsumerProjectLocalGetCompanyFinancialsWithHttpInfoAsync(companyId, atTimestamp, acceptEncoding, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Get company financials Returns historical financials data for single company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return financials snapshot for (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (CompanyFinancialsResponse)</returns>
        public async System.Threading.Tasks.Task<Org.OpenAPITools.Client.ApiResponse<CompanyFinancialsResponse>> ApiConsumerProjectLocalGetCompanyFinancialsWithHttpInfoAsync(string companyId, DateTime? atTimestamp = default(DateTime?), string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            // verify the required parameter 'companyId' is set
            if (companyId == null)
            {
                throw new Org.OpenAPITools.Client.ApiException(400, "Missing required parameter 'companyId' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyFinancials");
            }


            Org.OpenAPITools.Client.RequestOptions localVarRequestOptions = new Org.OpenAPITools.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = Org.OpenAPITools.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Org.OpenAPITools.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("companyId", Org.OpenAPITools.Client.ClientUtils.ParameterToString(companyId)); // path parameter
            if (atTimestamp != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "at_timestamp", atTimestamp));
            }
            if (acceptEncoding != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept-Encoding", Org.OpenAPITools.Client.ClientUtils.ParameterToString(acceptEncoding)); // header parameter
            }

            localVarRequestOptions.Operation = "DefaultApi.ApiConsumerProjectLocalGetCompanyFinancials";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (authorizeClient) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<CompanyFinancialsResponse>("/companies/{companyId}/financials", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("ApiConsumerProjectLocalGetCompanyFinancials", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Get company descriptions Returns a list of company description objects.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return companies snapshot for (optional)</param>
        /// <param name="isRetired">filter by &#39;retired&#39; status - (true|false) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids - comma separated list (optional)</param>
        /// <param name="tickers">filter by supplied company tickers (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="updatedAfter">Only return company descriptions added or updated on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="updatedBefore">Only return company descriptions added or updated before this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateAfter">Only return company descriptions for companies with reports on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateBefore">Only return company descriptions for companies with reports before this ISO-8601 timestamp (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>CompanyDescriptionResponse</returns>
        public CompanyDescriptionResponse ApiConsumerProjectLocalGetCompanyListings(DateTime? atTimestamp = default(DateTime?), string isRetired = default(string), string companyIds = default(string), string tickers = default(string), int? limit = default(int?), DateTime? updatedAfter = default(DateTime?), DateTime? updatedBefore = default(DateTime?), DateTime? lastReportedDateAfter = default(DateTime?), DateTime? lastReportedDateBefore = default(DateTime?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0)
        {
            Org.OpenAPITools.Client.ApiResponse<CompanyDescriptionResponse> localVarResponse = ApiConsumerProjectLocalGetCompanyListingsWithHttpInfo(atTimestamp, isRetired, companyIds, tickers, limit, updatedAfter, updatedBefore, lastReportedDateAfter, lastReportedDateBefore, continuationToken, acceptEncoding);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Get company descriptions Returns a list of company description objects.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return companies snapshot for (optional)</param>
        /// <param name="isRetired">filter by &#39;retired&#39; status - (true|false) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids - comma separated list (optional)</param>
        /// <param name="tickers">filter by supplied company tickers (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="updatedAfter">Only return company descriptions added or updated on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="updatedBefore">Only return company descriptions added or updated before this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateAfter">Only return company descriptions for companies with reports on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateBefore">Only return company descriptions for companies with reports before this ISO-8601 timestamp (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of CompanyDescriptionResponse</returns>
        public Org.OpenAPITools.Client.ApiResponse<CompanyDescriptionResponse> ApiConsumerProjectLocalGetCompanyListingsWithHttpInfo(DateTime? atTimestamp = default(DateTime?), string isRetired = default(string), string companyIds = default(string), string tickers = default(string), int? limit = default(int?), DateTime? updatedAfter = default(DateTime?), DateTime? updatedBefore = default(DateTime?), DateTime? lastReportedDateAfter = default(DateTime?), DateTime? lastReportedDateBefore = default(DateTime?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0)
        {
            Org.OpenAPITools.Client.RequestOptions localVarRequestOptions = new Org.OpenAPITools.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = Org.OpenAPITools.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Org.OpenAPITools.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            if (atTimestamp != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "at_timestamp", atTimestamp));
            }
            if (isRetired != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "is_retired", isRetired));
            }
            if (companyIds != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "company_ids", companyIds));
            }
            if (tickers != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "tickers", tickers));
            }
            if (limit != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "limit", limit));
            }
            if (updatedAfter != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "updated_after", updatedAfter));
            }
            if (updatedBefore != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "updated_before", updatedBefore));
            }
            if (lastReportedDateAfter != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "last_reported_date_after", lastReportedDateAfter));
            }
            if (lastReportedDateBefore != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "last_reported_date_before", lastReportedDateBefore));
            }
            if (continuationToken != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "continuation_token", continuationToken));
            }
            if (acceptEncoding != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept-Encoding", Org.OpenAPITools.Client.ClientUtils.ParameterToString(acceptEncoding)); // header parameter
            }

            localVarRequestOptions.Operation = "DefaultApi.ApiConsumerProjectLocalGetCompanyListings";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (authorizeClient) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<CompanyDescriptionResponse>("/companies", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("ApiConsumerProjectLocalGetCompanyListings", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Get company descriptions Returns a list of company description objects.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return companies snapshot for (optional)</param>
        /// <param name="isRetired">filter by &#39;retired&#39; status - (true|false) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids - comma separated list (optional)</param>
        /// <param name="tickers">filter by supplied company tickers (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="updatedAfter">Only return company descriptions added or updated on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="updatedBefore">Only return company descriptions added or updated before this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateAfter">Only return company descriptions for companies with reports on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateBefore">Only return company descriptions for companies with reports before this ISO-8601 timestamp (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of CompanyDescriptionResponse</returns>
        public async System.Threading.Tasks.Task<CompanyDescriptionResponse> ApiConsumerProjectLocalGetCompanyListingsAsync(DateTime? atTimestamp = default(DateTime?), string isRetired = default(string), string companyIds = default(string), string tickers = default(string), int? limit = default(int?), DateTime? updatedAfter = default(DateTime?), DateTime? updatedBefore = default(DateTime?), DateTime? lastReportedDateAfter = default(DateTime?), DateTime? lastReportedDateBefore = default(DateTime?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            Org.OpenAPITools.Client.ApiResponse<CompanyDescriptionResponse> localVarResponse = await ApiConsumerProjectLocalGetCompanyListingsWithHttpInfoAsync(atTimestamp, isRetired, companyIds, tickers, limit, updatedAfter, updatedBefore, lastReportedDateAfter, lastReportedDateBefore, continuationToken, acceptEncoding, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Get company descriptions Returns a list of company description objects.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="atTimestamp">ISO-8601 Timestamp to return companies snapshot for (optional)</param>
        /// <param name="isRetired">filter by &#39;retired&#39; status - (true|false) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids - comma separated list (optional)</param>
        /// <param name="tickers">filter by supplied company tickers (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="updatedAfter">Only return company descriptions added or updated on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="updatedBefore">Only return company descriptions added or updated before this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateAfter">Only return company descriptions for companies with reports on or after this ISO-8601 timestamp (optional)</param>
        /// <param name="lastReportedDateBefore">Only return company descriptions for companies with reports before this ISO-8601 timestamp (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (CompanyDescriptionResponse)</returns>
        public async System.Threading.Tasks.Task<Org.OpenAPITools.Client.ApiResponse<CompanyDescriptionResponse>> ApiConsumerProjectLocalGetCompanyListingsWithHttpInfoAsync(DateTime? atTimestamp = default(DateTime?), string isRetired = default(string), string companyIds = default(string), string tickers = default(string), int? limit = default(int?), DateTime? updatedAfter = default(DateTime?), DateTime? updatedBefore = default(DateTime?), DateTime? lastReportedDateAfter = default(DateTime?), DateTime? lastReportedDateBefore = default(DateTime?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {

            Org.OpenAPITools.Client.RequestOptions localVarRequestOptions = new Org.OpenAPITools.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = Org.OpenAPITools.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Org.OpenAPITools.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            if (atTimestamp != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "at_timestamp", atTimestamp));
            }
            if (isRetired != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "is_retired", isRetired));
            }
            if (companyIds != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "company_ids", companyIds));
            }
            if (tickers != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "tickers", tickers));
            }
            if (limit != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "limit", limit));
            }
            if (updatedAfter != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "updated_after", updatedAfter));
            }
            if (updatedBefore != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "updated_before", updatedBefore));
            }
            if (lastReportedDateAfter != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "last_reported_date_after", lastReportedDateAfter));
            }
            if (lastReportedDateBefore != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "last_reported_date_before", lastReportedDateBefore));
            }
            if (continuationToken != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "continuation_token", continuationToken));
            }
            if (acceptEncoding != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept-Encoding", Org.OpenAPITools.Client.ClientUtils.ParameterToString(acceptEncoding)); // header parameter
            }

            localVarRequestOptions.Operation = "DefaultApi.ApiConsumerProjectLocalGetCompanyListings";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (authorizeClient) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<CompanyDescriptionResponse>("/companies", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("ApiConsumerProjectLocalGetCompanyListings", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Get company time series Returns all historical values of a specific comparable for a given company and interval
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch time series data for</param>
        /// <param name="tag">identifier for the comparable tag to fetch time series data for</param>
        /// <param name="interval">identifier for the interval to fetch time series data for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>CompanyTimeSeriesResponse</returns>
        public CompanyTimeSeriesResponse ApiConsumerProjectLocalGetCompanyTimeSeries(string companyId, string tag, string interval, string acceptEncoding = default(string), int operationIndex = 0)
        {
            Org.OpenAPITools.Client.ApiResponse<CompanyTimeSeriesResponse> localVarResponse = ApiConsumerProjectLocalGetCompanyTimeSeriesWithHttpInfo(companyId, tag, interval, acceptEncoding);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Get company time series Returns all historical values of a specific comparable for a given company and interval
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch time series data for</param>
        /// <param name="tag">identifier for the comparable tag to fetch time series data for</param>
        /// <param name="interval">identifier for the interval to fetch time series data for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of CompanyTimeSeriesResponse</returns>
        public Org.OpenAPITools.Client.ApiResponse<CompanyTimeSeriesResponse> ApiConsumerProjectLocalGetCompanyTimeSeriesWithHttpInfo(string companyId, string tag, string interval, string acceptEncoding = default(string), int operationIndex = 0)
        {
            // verify the required parameter 'companyId' is set
            if (companyId == null)
            {
                throw new Org.OpenAPITools.Client.ApiException(400, "Missing required parameter 'companyId' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyTimeSeries");
            }

            // verify the required parameter 'tag' is set
            if (tag == null)
            {
                throw new Org.OpenAPITools.Client.ApiException(400, "Missing required parameter 'tag' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyTimeSeries");
            }

            // verify the required parameter 'interval' is set
            if (interval == null)
            {
                throw new Org.OpenAPITools.Client.ApiException(400, "Missing required parameter 'interval' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyTimeSeries");
            }

            Org.OpenAPITools.Client.RequestOptions localVarRequestOptions = new Org.OpenAPITools.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = Org.OpenAPITools.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Org.OpenAPITools.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("companyId", Org.OpenAPITools.Client.ClientUtils.ParameterToString(companyId)); // path parameter
            localVarRequestOptions.PathParameters.Add("tag", Org.OpenAPITools.Client.ClientUtils.ParameterToString(tag)); // path parameter
            localVarRequestOptions.PathParameters.Add("interval", Org.OpenAPITools.Client.ClientUtils.ParameterToString(interval)); // path parameter
            if (acceptEncoding != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept-Encoding", Org.OpenAPITools.Client.ClientUtils.ParameterToString(acceptEncoding)); // header parameter
            }

            localVarRequestOptions.Operation = "DefaultApi.ApiConsumerProjectLocalGetCompanyTimeSeries";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (authorizeClient) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<CompanyTimeSeriesResponse>("/companies/{companyId}/timeseries/{tag}/{interval}", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("ApiConsumerProjectLocalGetCompanyTimeSeries", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Get company time series Returns all historical values of a specific comparable for a given company and interval
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch time series data for</param>
        /// <param name="tag">identifier for the comparable tag to fetch time series data for</param>
        /// <param name="interval">identifier for the interval to fetch time series data for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of CompanyTimeSeriesResponse</returns>
        public async System.Threading.Tasks.Task<CompanyTimeSeriesResponse> ApiConsumerProjectLocalGetCompanyTimeSeriesAsync(string companyId, string tag, string interval, string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            Org.OpenAPITools.Client.ApiResponse<CompanyTimeSeriesResponse> localVarResponse = await ApiConsumerProjectLocalGetCompanyTimeSeriesWithHttpInfoAsync(companyId, tag, interval, acceptEncoding, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Get company time series Returns all historical values of a specific comparable for a given company and interval
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch time series data for</param>
        /// <param name="tag">identifier for the comparable tag to fetch time series data for</param>
        /// <param name="interval">identifier for the interval to fetch time series data for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (CompanyTimeSeriesResponse)</returns>
        public async System.Threading.Tasks.Task<Org.OpenAPITools.Client.ApiResponse<CompanyTimeSeriesResponse>> ApiConsumerProjectLocalGetCompanyTimeSeriesWithHttpInfoAsync(string companyId, string tag, string interval, string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            // verify the required parameter 'companyId' is set
            if (companyId == null)
            {
                throw new Org.OpenAPITools.Client.ApiException(400, "Missing required parameter 'companyId' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyTimeSeries");
            }

            // verify the required parameter 'tag' is set
            if (tag == null)
            {
                throw new Org.OpenAPITools.Client.ApiException(400, "Missing required parameter 'tag' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyTimeSeries");
            }

            // verify the required parameter 'interval' is set
            if (interval == null)
            {
                throw new Org.OpenAPITools.Client.ApiException(400, "Missing required parameter 'interval' when calling DefaultApi->ApiConsumerProjectLocalGetCompanyTimeSeries");
            }


            Org.OpenAPITools.Client.RequestOptions localVarRequestOptions = new Org.OpenAPITools.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = Org.OpenAPITools.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Org.OpenAPITools.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("companyId", Org.OpenAPITools.Client.ClientUtils.ParameterToString(companyId)); // path parameter
            localVarRequestOptions.PathParameters.Add("tag", Org.OpenAPITools.Client.ClientUtils.ParameterToString(tag)); // path parameter
            localVarRequestOptions.PathParameters.Add("interval", Org.OpenAPITools.Client.ClientUtils.ParameterToString(interval)); // path parameter
            if (acceptEncoding != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept-Encoding", Org.OpenAPITools.Client.ClientUtils.ParameterToString(acceptEncoding)); // header parameter
            }

            localVarRequestOptions.Operation = "DefaultApi.ApiConsumerProjectLocalGetCompanyTimeSeries";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (authorizeClient) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<CompanyTimeSeriesResponse>("/companies/{companyId}/timeseries/{tag}/{interval}", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("ApiConsumerProjectLocalGetCompanyTimeSeries", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Get company comparables updates for a given time period Returns comparables data for a list of companies for the allowed coverage_universe, from a given start timestamp and optional end timestamp
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="startTimestamp">ISO-8601 Timestamp to return comparables updates since (all updates greater than or equal to the timestamp) (optional)</param>
        /// <param name="endTimestamp">ISO-8601 Timestamp to return comparables updates until (all updates less than, but not equal to, the timestamp) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ComparablesResponse</returns>
        public ComparablesResponse ApiConsumerProjectLocalGetComparablesUpdatesSince(DateTime? startTimestamp = default(DateTime?), DateTime? endTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0)
        {
            Org.OpenAPITools.Client.ApiResponse<ComparablesResponse> localVarResponse = ApiConsumerProjectLocalGetComparablesUpdatesSinceWithHttpInfo(startTimestamp, endTimestamp, companyIds, limit, continuationToken, acceptEncoding);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Get company comparables updates for a given time period Returns comparables data for a list of companies for the allowed coverage_universe, from a given start timestamp and optional end timestamp
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="startTimestamp">ISO-8601 Timestamp to return comparables updates since (all updates greater than or equal to the timestamp) (optional)</param>
        /// <param name="endTimestamp">ISO-8601 Timestamp to return comparables updates until (all updates less than, but not equal to, the timestamp) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of ComparablesResponse</returns>
        public Org.OpenAPITools.Client.ApiResponse<ComparablesResponse> ApiConsumerProjectLocalGetComparablesUpdatesSinceWithHttpInfo(DateTime? startTimestamp = default(DateTime?), DateTime? endTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0)
        {
            Org.OpenAPITools.Client.RequestOptions localVarRequestOptions = new Org.OpenAPITools.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = Org.OpenAPITools.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Org.OpenAPITools.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            if (startTimestamp != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "start_timestamp", startTimestamp));
            }
            if (endTimestamp != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "end_timestamp", endTimestamp));
            }
            if (companyIds != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "company_ids", companyIds));
            }
            if (limit != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "limit", limit));
            }
            if (continuationToken != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "continuation_token", continuationToken));
            }
            if (acceptEncoding != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept-Encoding", Org.OpenAPITools.Client.ClientUtils.ParameterToString(acceptEncoding)); // header parameter
            }

            localVarRequestOptions.Operation = "DefaultApi.ApiConsumerProjectLocalGetComparablesUpdatesSince";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (authorizeClient) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<ComparablesResponse>("/comparables/updates", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("ApiConsumerProjectLocalGetComparablesUpdatesSince", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Get company comparables updates for a given time period Returns comparables data for a list of companies for the allowed coverage_universe, from a given start timestamp and optional end timestamp
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="startTimestamp">ISO-8601 Timestamp to return comparables updates since (all updates greater than or equal to the timestamp) (optional)</param>
        /// <param name="endTimestamp">ISO-8601 Timestamp to return comparables updates until (all updates less than, but not equal to, the timestamp) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ComparablesResponse</returns>
        public async System.Threading.Tasks.Task<ComparablesResponse> ApiConsumerProjectLocalGetComparablesUpdatesSinceAsync(DateTime? startTimestamp = default(DateTime?), DateTime? endTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            Org.OpenAPITools.Client.ApiResponse<ComparablesResponse> localVarResponse = await ApiConsumerProjectLocalGetComparablesUpdatesSinceWithHttpInfoAsync(startTimestamp, endTimestamp, companyIds, limit, continuationToken, acceptEncoding, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Get company comparables updates for a given time period Returns comparables data for a list of companies for the allowed coverage_universe, from a given start timestamp and optional end timestamp
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="startTimestamp">ISO-8601 Timestamp to return comparables updates since (all updates greater than or equal to the timestamp) (optional)</param>
        /// <param name="endTimestamp">ISO-8601 Timestamp to return comparables updates until (all updates less than, but not equal to, the timestamp) (optional)</param>
        /// <param name="companyIds">filter by supplied company ids (optional)</param>
        /// <param name="limit">maximum number of results to return - typically used when paging (optional)</param>
        /// <param name="continuationToken">identifier of last result in previous result set - allows continuation of paged results (optional)</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (ComparablesResponse)</returns>
        public async System.Threading.Tasks.Task<Org.OpenAPITools.Client.ApiResponse<ComparablesResponse>> ApiConsumerProjectLocalGetComparablesUpdatesSinceWithHttpInfoAsync(DateTime? startTimestamp = default(DateTime?), DateTime? endTimestamp = default(DateTime?), string companyIds = default(string), int? limit = default(int?), string continuationToken = default(string), string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {

            Org.OpenAPITools.Client.RequestOptions localVarRequestOptions = new Org.OpenAPITools.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = Org.OpenAPITools.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Org.OpenAPITools.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            if (startTimestamp != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "start_timestamp", startTimestamp));
            }
            if (endTimestamp != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "end_timestamp", endTimestamp));
            }
            if (companyIds != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "company_ids", companyIds));
            }
            if (limit != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "limit", limit));
            }
            if (continuationToken != null)
            {
                localVarRequestOptions.QueryParameters.Add(Org.OpenAPITools.Client.ClientUtils.ParameterToMultiMap("", "continuation_token", continuationToken));
            }
            if (acceptEncoding != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept-Encoding", Org.OpenAPITools.Client.ClientUtils.ParameterToString(acceptEncoding)); // header parameter
            }

            localVarRequestOptions.Operation = "DefaultApi.ApiConsumerProjectLocalGetComparablesUpdatesSince";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (authorizeClient) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<ComparablesResponse>("/comparables/updates", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("ApiConsumerProjectLocalGetComparablesUpdatesSince", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Get company period dates Returns end dates of financial reporting periods for given company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>CompanyPeriodDatesResponse</returns>
        public CompanyPeriodDatesResponse ApiConsumerProjectLocalGetPeriodDates(string companyId, string acceptEncoding = default(string), int operationIndex = 0)
        {
            Org.OpenAPITools.Client.ApiResponse<CompanyPeriodDatesResponse> localVarResponse = ApiConsumerProjectLocalGetPeriodDatesWithHttpInfo(companyId, acceptEncoding);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Get company period dates Returns end dates of financial reporting periods for given company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of CompanyPeriodDatesResponse</returns>
        public Org.OpenAPITools.Client.ApiResponse<CompanyPeriodDatesResponse> ApiConsumerProjectLocalGetPeriodDatesWithHttpInfo(string companyId, string acceptEncoding = default(string), int operationIndex = 0)
        {
            // verify the required parameter 'companyId' is set
            if (companyId == null)
            {
                throw new Org.OpenAPITools.Client.ApiException(400, "Missing required parameter 'companyId' when calling DefaultApi->ApiConsumerProjectLocalGetPeriodDates");
            }

            Org.OpenAPITools.Client.RequestOptions localVarRequestOptions = new Org.OpenAPITools.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = Org.OpenAPITools.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Org.OpenAPITools.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("companyId", Org.OpenAPITools.Client.ClientUtils.ParameterToString(companyId)); // path parameter
            if (acceptEncoding != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept-Encoding", Org.OpenAPITools.Client.ClientUtils.ParameterToString(acceptEncoding)); // header parameter
            }

            localVarRequestOptions.Operation = "DefaultApi.ApiConsumerProjectLocalGetPeriodDates";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (authorizeClient) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<CompanyPeriodDatesResponse>("/companies/{companyId}/periods", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("ApiConsumerProjectLocalGetPeriodDates", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Get company period dates Returns end dates of financial reporting periods for given company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of CompanyPeriodDatesResponse</returns>
        public async System.Threading.Tasks.Task<CompanyPeriodDatesResponse> ApiConsumerProjectLocalGetPeriodDatesAsync(string companyId, string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            Org.OpenAPITools.Client.ApiResponse<CompanyPeriodDatesResponse> localVarResponse = await ApiConsumerProjectLocalGetPeriodDatesWithHttpInfoAsync(companyId, acceptEncoding, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Get company period dates Returns end dates of financial reporting periods for given company
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="companyId">identifier for the company to fetch financials for</param>
        /// <param name="acceptEncoding">client supported encodings (gzip, deflate, br) (optional, default to &quot;gzip, deflate, br&quot;)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (CompanyPeriodDatesResponse)</returns>
        public async System.Threading.Tasks.Task<Org.OpenAPITools.Client.ApiResponse<CompanyPeriodDatesResponse>> ApiConsumerProjectLocalGetPeriodDatesWithHttpInfoAsync(string companyId, string acceptEncoding = default(string), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            // verify the required parameter 'companyId' is set
            if (companyId == null)
            {
                throw new Org.OpenAPITools.Client.ApiException(400, "Missing required parameter 'companyId' when calling DefaultApi->ApiConsumerProjectLocalGetPeriodDates");
            }


            Org.OpenAPITools.Client.RequestOptions localVarRequestOptions = new Org.OpenAPITools.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json"
            };

            var localVarContentType = Org.OpenAPITools.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Org.OpenAPITools.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("companyId", Org.OpenAPITools.Client.ClientUtils.ParameterToString(companyId)); // path parameter
            if (acceptEncoding != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept-Encoding", Org.OpenAPITools.Client.ClientUtils.ParameterToString(acceptEncoding)); // header parameter
            }

            localVarRequestOptions.Operation = "DefaultApi.ApiConsumerProjectLocalGetPeriodDates";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (authorizeClient) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("x-api-key")))
            {
                localVarRequestOptions.HeaderParameters.Add("x-api-key", this.Configuration.GetApiKeyWithPrefix("x-api-key"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<CompanyPeriodDatesResponse>("/companies/{companyId}/periods", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("ApiConsumerProjectLocalGetPeriodDates", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

    }
}
