/*
 * Data API
 *
 * Cognitive Credit Company Data API
 *
 * The version of the OpenAPI document: 1.0.0
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// CommentRefsInner
    /// </summary>
    [DataContract(Name = "comment_refs_inner")]
    public partial class CommentRefsInner : IEquatable<CommentRefsInner>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CommentRefsInner" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected CommentRefsInner() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="CommentRefsInner" /> class.
        /// </summary>
        /// <param name="doc">doc (required).</param>
        /// <param name="label">label (required).</param>
        /// <param name="page">page (required).</param>
        public CommentRefsInner(string doc = default(string), string label = default(string), int page = default(int))
        {
            // to ensure "doc" is required (not null)
            if (doc == null)
            {
                throw new ArgumentNullException("doc is a required property for CommentRefsInner and cannot be null");
            }
            this.Doc = doc;
            // to ensure "label" is required (not null)
            if (label == null)
            {
                throw new ArgumentNullException("label is a required property for CommentRefsInner and cannot be null");
            }
            this.Label = label;
            this.Page = page;
        }

        /// <summary>
        /// Gets or Sets Doc
        /// </summary>
        [DataMember(Name = "doc", IsRequired = true, EmitDefaultValue = true)]
        public string Doc { get; set; }

        /// <summary>
        /// Gets or Sets Label
        /// </summary>
        [DataMember(Name = "label", IsRequired = true, EmitDefaultValue = true)]
        public string Label { get; set; }

        /// <summary>
        /// Gets or Sets Page
        /// </summary>
        [DataMember(Name = "page", IsRequired = true, EmitDefaultValue = true)]
        public int Page { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class CommentRefsInner {\n");
            sb.Append("  Doc: ").Append(Doc).Append("\n");
            sb.Append("  Label: ").Append(Label).Append("\n");
            sb.Append("  Page: ").Append(Page).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CommentRefsInner);
        }

        /// <summary>
        /// Returns true if CommentRefsInner instances are equal
        /// </summary>
        /// <param name="input">Instance of CommentRefsInner to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CommentRefsInner input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Doc == input.Doc ||
                    (this.Doc != null &&
                    this.Doc.Equals(input.Doc))
                ) && 
                (
                    this.Label == input.Label ||
                    (this.Label != null &&
                    this.Label.Equals(input.Label))
                ) && 
                (
                    this.Page == input.Page ||
                    this.Page.Equals(input.Page)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Doc != null)
                {
                    hashCode = (hashCode * 59) + this.Doc.GetHashCode();
                }
                if (this.Label != null)
                {
                    hashCode = (hashCode * 59) + this.Label.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.Page.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
