/*
 * Data API
 *
 * Cognitive Credit Company Data API
 *
 * The version of the OpenAPI document: 1.0.0
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// CompanyDatapointResponseData
    /// </summary>
    [DataContract(Name = "CompanyDatapointResponse_data")]
    public partial class CompanyDatapointResponseData : IEquatable<CompanyDatapointResponseData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CompanyDatapointResponseData" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected CompanyDatapointResponseData() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="CompanyDatapointResponseData" /> class.
        /// </summary>
        /// <param name="comment">comment (required).</param>
        /// <param name="commentRefs">commentRefs (required).</param>
        /// <param name="companyId">companyId (required).</param>
        /// <param name="displayLabel">displayLabel (required).</param>
        /// <param name="generatedAt">generatedAt (required).</param>
        /// <param name="id">id (required).</param>
        /// <param name="notMeaningful">notMeaningful (required).</param>
        /// <param name="pageNumber">pageNumber (required).</param>
        /// <param name="parts">parts (required).</param>
        /// <param name="period">period (required).</param>
        /// <param name="sourceDoc">sourceDoc (required).</param>
        /// <param name="sourceType">sourceType (required).</param>
        /// <param name="tag">tag (required).</param>
        /// <param name="updatedAt">updatedAt (required).</param>
        /// <param name="value">value (required).</param>
        public CompanyDatapointResponseData(string comment = default(string), List<CommentRefsInner> commentRefs = default(List<CommentRefsInner>), string companyId = default(string), string displayLabel = default(string), DateTime generatedAt = default(DateTime), string id = default(string), bool? notMeaningful = default(bool?), int? pageNumber = default(int?), List<PartsInner> parts = default(List<PartsInner>), string period = default(string), string sourceDoc = default(string), string sourceType = default(string), string tag = default(string), DateTime updatedAt = default(DateTime), string value = default(string))
        {
            // to ensure "comment" is required (not null)
            if (comment == null)
            {
                throw new ArgumentNullException("comment is a required property for CompanyDatapointResponseData and cannot be null");
            }
            this.Comment = comment;
            // to ensure "commentRefs" is required (not null)
            if (commentRefs == null)
            {
                throw new ArgumentNullException("commentRefs is a required property for CompanyDatapointResponseData and cannot be null");
            }
            this.CommentRefs = commentRefs;
            // to ensure "companyId" is required (not null)
            if (companyId == null)
            {
                throw new ArgumentNullException("companyId is a required property for CompanyDatapointResponseData and cannot be null");
            }
            this.CompanyId = companyId;
            // to ensure "displayLabel" is required (not null)
            if (displayLabel == null)
            {
                throw new ArgumentNullException("displayLabel is a required property for CompanyDatapointResponseData and cannot be null");
            }
            this.DisplayLabel = displayLabel;
            this.GeneratedAt = generatedAt;
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new ArgumentNullException("id is a required property for CompanyDatapointResponseData and cannot be null");
            }
            this.Id = id;
            // to ensure "notMeaningful" is required (not null)
            if (notMeaningful == null)
            {
                throw new ArgumentNullException("notMeaningful is a required property for CompanyDatapointResponseData and cannot be null");
            }
            this.NotMeaningful = notMeaningful;
            // to ensure "pageNumber" is required (not null)
            if (pageNumber == null)
            {
                throw new ArgumentNullException("pageNumber is a required property for CompanyDatapointResponseData and cannot be null");
            }
            this.PageNumber = pageNumber;
            // to ensure "parts" is required (not null)
            if (parts == null)
            {
                throw new ArgumentNullException("parts is a required property for CompanyDatapointResponseData and cannot be null");
            }
            this.Parts = parts;
            // to ensure "period" is required (not null)
            if (period == null)
            {
                throw new ArgumentNullException("period is a required property for CompanyDatapointResponseData and cannot be null");
            }
            this.Period = period;
            // to ensure "sourceDoc" is required (not null)
            if (sourceDoc == null)
            {
                throw new ArgumentNullException("sourceDoc is a required property for CompanyDatapointResponseData and cannot be null");
            }
            this.SourceDoc = sourceDoc;
            // to ensure "sourceType" is required (not null)
            if (sourceType == null)
            {
                throw new ArgumentNullException("sourceType is a required property for CompanyDatapointResponseData and cannot be null");
            }
            this.SourceType = sourceType;
            // to ensure "tag" is required (not null)
            if (tag == null)
            {
                throw new ArgumentNullException("tag is a required property for CompanyDatapointResponseData and cannot be null");
            }
            this.Tag = tag;
            this.UpdatedAt = updatedAt;
            // to ensure "value" is required (not null)
            if (value == null)
            {
                throw new ArgumentNullException("value is a required property for CompanyDatapointResponseData and cannot be null");
            }
            this.Value = value;
        }

        /// <summary>
        /// Gets or Sets Comment
        /// </summary>
        [DataMember(Name = "comment", IsRequired = true, EmitDefaultValue = true)]
        public string Comment { get; set; }

        /// <summary>
        /// Gets or Sets CommentRefs
        /// </summary>
        [DataMember(Name = "comment_refs", IsRequired = true, EmitDefaultValue = true)]
        public List<CommentRefsInner> CommentRefs { get; set; }

        /// <summary>
        /// Gets or Sets CompanyId
        /// </summary>
        [DataMember(Name = "company_id", IsRequired = true, EmitDefaultValue = true)]
        public string CompanyId { get; set; }

        /// <summary>
        /// Gets or Sets DisplayLabel
        /// </summary>
        [DataMember(Name = "display_label", IsRequired = true, EmitDefaultValue = true)]
        public string DisplayLabel { get; set; }

        /// <summary>
        /// Gets or Sets GeneratedAt
        /// </summary>
        [DataMember(Name = "generated_at", IsRequired = true, EmitDefaultValue = true)]
        public DateTime GeneratedAt { get; set; }

        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name = "id", IsRequired = true, EmitDefaultValue = true)]
        public string Id { get; set; }

        /// <summary>
        /// Gets or Sets NotMeaningful
        /// </summary>
        [DataMember(Name = "not_meaningful", IsRequired = true, EmitDefaultValue = true)]
        public bool? NotMeaningful { get; set; }

        /// <summary>
        /// Gets or Sets PageNumber
        /// </summary>
        [DataMember(Name = "page_number", IsRequired = true, EmitDefaultValue = true)]
        public int? PageNumber { get; set; }

        /// <summary>
        /// Gets or Sets Parts
        /// </summary>
        [DataMember(Name = "parts", IsRequired = true, EmitDefaultValue = true)]
        public List<PartsInner> Parts { get; set; }

        /// <summary>
        /// Gets or Sets Period
        /// </summary>
        [DataMember(Name = "period", IsRequired = true, EmitDefaultValue = true)]
        public string Period { get; set; }

        /// <summary>
        /// Gets or Sets SourceDoc
        /// </summary>
        [DataMember(Name = "source_doc", IsRequired = true, EmitDefaultValue = true)]
        public string SourceDoc { get; set; }

        /// <summary>
        /// Gets or Sets SourceType
        /// </summary>
        [DataMember(Name = "source_type", IsRequired = true, EmitDefaultValue = true)]
        public string SourceType { get; set; }

        /// <summary>
        /// Gets or Sets Tag
        /// </summary>
        [DataMember(Name = "tag", IsRequired = true, EmitDefaultValue = true)]
        public string Tag { get; set; }

        /// <summary>
        /// Gets or Sets UpdatedAt
        /// </summary>
        [DataMember(Name = "updated_at", IsRequired = true, EmitDefaultValue = true)]
        public DateTime UpdatedAt { get; set; }

        /// <summary>
        /// Gets or Sets Value
        /// </summary>
        [DataMember(Name = "value", IsRequired = true, EmitDefaultValue = true)]
        public string Value { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class CompanyDatapointResponseData {\n");
            sb.Append("  Comment: ").Append(Comment).Append("\n");
            sb.Append("  CommentRefs: ").Append(CommentRefs).Append("\n");
            sb.Append("  CompanyId: ").Append(CompanyId).Append("\n");
            sb.Append("  DisplayLabel: ").Append(DisplayLabel).Append("\n");
            sb.Append("  GeneratedAt: ").Append(GeneratedAt).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  NotMeaningful: ").Append(NotMeaningful).Append("\n");
            sb.Append("  PageNumber: ").Append(PageNumber).Append("\n");
            sb.Append("  Parts: ").Append(Parts).Append("\n");
            sb.Append("  Period: ").Append(Period).Append("\n");
            sb.Append("  SourceDoc: ").Append(SourceDoc).Append("\n");
            sb.Append("  SourceType: ").Append(SourceType).Append("\n");
            sb.Append("  Tag: ").Append(Tag).Append("\n");
            sb.Append("  UpdatedAt: ").Append(UpdatedAt).Append("\n");
            sb.Append("  Value: ").Append(Value).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CompanyDatapointResponseData);
        }

        /// <summary>
        /// Returns true if CompanyDatapointResponseData instances are equal
        /// </summary>
        /// <param name="input">Instance of CompanyDatapointResponseData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CompanyDatapointResponseData input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Comment == input.Comment ||
                    (this.Comment != null &&
                    this.Comment.Equals(input.Comment))
                ) && 
                (
                    this.CommentRefs == input.CommentRefs ||
                    this.CommentRefs != null &&
                    input.CommentRefs != null &&
                    this.CommentRefs.SequenceEqual(input.CommentRefs)
                ) && 
                (
                    this.CompanyId == input.CompanyId ||
                    (this.CompanyId != null &&
                    this.CompanyId.Equals(input.CompanyId))
                ) && 
                (
                    this.DisplayLabel == input.DisplayLabel ||
                    (this.DisplayLabel != null &&
                    this.DisplayLabel.Equals(input.DisplayLabel))
                ) && 
                (
                    this.GeneratedAt == input.GeneratedAt ||
                    (this.GeneratedAt != null &&
                    this.GeneratedAt.Equals(input.GeneratedAt))
                ) && 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.NotMeaningful == input.NotMeaningful ||
                    (this.NotMeaningful != null &&
                    this.NotMeaningful.Equals(input.NotMeaningful))
                ) && 
                (
                    this.PageNumber == input.PageNumber ||
                    (this.PageNumber != null &&
                    this.PageNumber.Equals(input.PageNumber))
                ) && 
                (
                    this.Parts == input.Parts ||
                    this.Parts != null &&
                    input.Parts != null &&
                    this.Parts.SequenceEqual(input.Parts)
                ) && 
                (
                    this.Period == input.Period ||
                    (this.Period != null &&
                    this.Period.Equals(input.Period))
                ) && 
                (
                    this.SourceDoc == input.SourceDoc ||
                    (this.SourceDoc != null &&
                    this.SourceDoc.Equals(input.SourceDoc))
                ) && 
                (
                    this.SourceType == input.SourceType ||
                    (this.SourceType != null &&
                    this.SourceType.Equals(input.SourceType))
                ) && 
                (
                    this.Tag == input.Tag ||
                    (this.Tag != null &&
                    this.Tag.Equals(input.Tag))
                ) && 
                (
                    this.UpdatedAt == input.UpdatedAt ||
                    (this.UpdatedAt != null &&
                    this.UpdatedAt.Equals(input.UpdatedAt))
                ) && 
                (
                    this.Value == input.Value ||
                    (this.Value != null &&
                    this.Value.Equals(input.Value))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Comment != null)
                {
                    hashCode = (hashCode * 59) + this.Comment.GetHashCode();
                }
                if (this.CommentRefs != null)
                {
                    hashCode = (hashCode * 59) + this.CommentRefs.GetHashCode();
                }
                if (this.CompanyId != null)
                {
                    hashCode = (hashCode * 59) + this.CompanyId.GetHashCode();
                }
                if (this.DisplayLabel != null)
                {
                    hashCode = (hashCode * 59) + this.DisplayLabel.GetHashCode();
                }
                if (this.GeneratedAt != null)
                {
                    hashCode = (hashCode * 59) + this.GeneratedAt.GetHashCode();
                }
                if (this.Id != null)
                {
                    hashCode = (hashCode * 59) + this.Id.GetHashCode();
                }
                if (this.NotMeaningful != null)
                {
                    hashCode = (hashCode * 59) + this.NotMeaningful.GetHashCode();
                }
                if (this.PageNumber != null)
                {
                    hashCode = (hashCode * 59) + this.PageNumber.GetHashCode();
                }
                if (this.Parts != null)
                {
                    hashCode = (hashCode * 59) + this.Parts.GetHashCode();
                }
                if (this.Period != null)
                {
                    hashCode = (hashCode * 59) + this.Period.GetHashCode();
                }
                if (this.SourceDoc != null)
                {
                    hashCode = (hashCode * 59) + this.SourceDoc.GetHashCode();
                }
                if (this.SourceType != null)
                {
                    hashCode = (hashCode * 59) + this.SourceType.GetHashCode();
                }
                if (this.Tag != null)
                {
                    hashCode = (hashCode * 59) + this.Tag.GetHashCode();
                }
                if (this.UpdatedAt != null)
                {
                    hashCode = (hashCode * 59) + this.UpdatedAt.GetHashCode();
                }
                if (this.Value != null)
                {
                    hashCode = (hashCode * 59) + this.Value.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
