/*
 * Data API
 *
 * Cognitive Credit Company Data API
 *
 * The version of the OpenAPI document: 1.0.0
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// CompanyPeriodDatesResponseData
    /// </summary>
    [DataContract(Name = "CompanyPeriodDatesResponse_data")]
    public partial class CompanyPeriodDatesResponseData : IEquatable<CompanyPeriodDatesResponseData>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CompanyPeriodDatesResponseData" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected CompanyPeriodDatesResponseData() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="CompanyPeriodDatesResponseData" /> class.
        /// </summary>
        /// <param name="companyId">companyId (required).</param>
        /// <param name="generatedAt">generatedAt (required).</param>
        /// <param name="periodDates">periodDates.</param>
        /// <param name="updatedAt">updatedAt (required).</param>
        public CompanyPeriodDatesResponseData(string companyId = default(string), DateTime generatedAt = default(DateTime), List<PeriodDatesInner> periodDates = default(List<PeriodDatesInner>), DateTime updatedAt = default(DateTime))
        {
            // to ensure "companyId" is required (not null)
            if (companyId == null)
            {
                throw new ArgumentNullException("companyId is a required property for CompanyPeriodDatesResponseData and cannot be null");
            }
            this.CompanyId = companyId;
            this.GeneratedAt = generatedAt;
            this.UpdatedAt = updatedAt;
            this.PeriodDates = periodDates;
        }

        /// <summary>
        /// Gets or Sets CompanyId
        /// </summary>
        [DataMember(Name = "company_id", IsRequired = true, EmitDefaultValue = true)]
        public string CompanyId { get; set; }

        /// <summary>
        /// Gets or Sets GeneratedAt
        /// </summary>
        [DataMember(Name = "generated_at", IsRequired = true, EmitDefaultValue = true)]
        public DateTime GeneratedAt { get; set; }

        /// <summary>
        /// Gets or Sets PeriodDates
        /// </summary>
        [DataMember(Name = "period_dates", EmitDefaultValue = false)]
        public List<PeriodDatesInner> PeriodDates { get; set; }

        /// <summary>
        /// Gets or Sets UpdatedAt
        /// </summary>
        [DataMember(Name = "updated_at", IsRequired = true, EmitDefaultValue = true)]
        public DateTime UpdatedAt { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class CompanyPeriodDatesResponseData {\n");
            sb.Append("  CompanyId: ").Append(CompanyId).Append("\n");
            sb.Append("  GeneratedAt: ").Append(GeneratedAt).Append("\n");
            sb.Append("  PeriodDates: ").Append(PeriodDates).Append("\n");
            sb.Append("  UpdatedAt: ").Append(UpdatedAt).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CompanyPeriodDatesResponseData);
        }

        /// <summary>
        /// Returns true if CompanyPeriodDatesResponseData instances are equal
        /// </summary>
        /// <param name="input">Instance of CompanyPeriodDatesResponseData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CompanyPeriodDatesResponseData input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.CompanyId == input.CompanyId ||
                    (this.CompanyId != null &&
                    this.CompanyId.Equals(input.CompanyId))
                ) && 
                (
                    this.GeneratedAt == input.GeneratedAt ||
                    (this.GeneratedAt != null &&
                    this.GeneratedAt.Equals(input.GeneratedAt))
                ) && 
                (
                    this.PeriodDates == input.PeriodDates ||
                    this.PeriodDates != null &&
                    input.PeriodDates != null &&
                    this.PeriodDates.SequenceEqual(input.PeriodDates)
                ) && 
                (
                    this.UpdatedAt == input.UpdatedAt ||
                    (this.UpdatedAt != null &&
                    this.UpdatedAt.Equals(input.UpdatedAt))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.CompanyId != null)
                {
                    hashCode = (hashCode * 59) + this.CompanyId.GetHashCode();
                }
                if (this.GeneratedAt != null)
                {
                    hashCode = (hashCode * 59) + this.GeneratedAt.GetHashCode();
                }
                if (this.PeriodDates != null)
                {
                    hashCode = (hashCode * 59) + this.PeriodDates.GetHashCode();
                }
                if (this.UpdatedAt != null)
                {
                    hashCode = (hashCode * 59) + this.UpdatedAt.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
