/*
 * Data API
 *
 * Cognitive Credit Company Data API
 *
 * The version of the OpenAPI document: 1.0.0
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// DataInner1
    /// </summary>
    [DataContract(Name = "data_inner_1")]
    public partial class DataInner1 : IEquatable<DataInner1>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DataInner1" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected DataInner1() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="DataInner1" /> class.
        /// </summary>
        /// <param name="companyId">companyId (required).</param>
        /// <param name="comparables">comparables.</param>
        /// <param name="generatedAt">generatedAt (required).</param>
        /// <param name="id">id.</param>
        /// <param name="interval">interval (required).</param>
        /// <param name="reportPeriod">reportPeriod (required).</param>
        /// <param name="updatedAt">updatedAt (required).</param>
        public DataInner1(string companyId = default(string), List<ComparablesInner> comparables = default(List<ComparablesInner>), DateTime generatedAt = default(DateTime), int id = default(int), string interval = default(string), string reportPeriod = default(string), DateTime updatedAt = default(DateTime))
        {
            // to ensure "companyId" is required (not null)
            if (companyId == null)
            {
                throw new ArgumentNullException("companyId is a required property for DataInner1 and cannot be null");
            }
            this.CompanyId = companyId;
            this.GeneratedAt = generatedAt;
            // to ensure "interval" is required (not null)
            if (interval == null)
            {
                throw new ArgumentNullException("interval is a required property for DataInner1 and cannot be null");
            }
            this.Interval = interval;
            // to ensure "reportPeriod" is required (not null)
            if (reportPeriod == null)
            {
                throw new ArgumentNullException("reportPeriod is a required property for DataInner1 and cannot be null");
            }
            this.ReportPeriod = reportPeriod;
            this.UpdatedAt = updatedAt;
            this.Comparables = comparables;
            this.Id = id;
        }

        /// <summary>
        /// Gets or Sets CompanyId
        /// </summary>
        [DataMember(Name = "company_id", IsRequired = true, EmitDefaultValue = true)]
        public string CompanyId { get; set; }

        /// <summary>
        /// Gets or Sets Comparables
        /// </summary>
        [DataMember(Name = "comparables", EmitDefaultValue = false)]
        public List<ComparablesInner> Comparables { get; set; }

        /// <summary>
        /// Gets or Sets GeneratedAt
        /// </summary>
        [DataMember(Name = "generated_at", IsRequired = true, EmitDefaultValue = true)]
        public DateTime GeneratedAt { get; set; }

        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name = "id", EmitDefaultValue = false)]
        public int Id { get; set; }

        /// <summary>
        /// Gets or Sets Interval
        /// </summary>
        [DataMember(Name = "interval", IsRequired = true, EmitDefaultValue = true)]
        public string Interval { get; set; }

        /// <summary>
        /// Gets or Sets ReportPeriod
        /// </summary>
        [DataMember(Name = "report_period", IsRequired = true, EmitDefaultValue = true)]
        public string ReportPeriod { get; set; }

        /// <summary>
        /// Gets or Sets UpdatedAt
        /// </summary>
        [DataMember(Name = "updated_at", IsRequired = true, EmitDefaultValue = true)]
        public DateTime UpdatedAt { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class DataInner1 {\n");
            sb.Append("  CompanyId: ").Append(CompanyId).Append("\n");
            sb.Append("  Comparables: ").Append(Comparables).Append("\n");
            sb.Append("  GeneratedAt: ").Append(GeneratedAt).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Interval: ").Append(Interval).Append("\n");
            sb.Append("  ReportPeriod: ").Append(ReportPeriod).Append("\n");
            sb.Append("  UpdatedAt: ").Append(UpdatedAt).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as DataInner1);
        }

        /// <summary>
        /// Returns true if DataInner1 instances are equal
        /// </summary>
        /// <param name="input">Instance of DataInner1 to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DataInner1 input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.CompanyId == input.CompanyId ||
                    (this.CompanyId != null &&
                    this.CompanyId.Equals(input.CompanyId))
                ) && 
                (
                    this.Comparables == input.Comparables ||
                    this.Comparables != null &&
                    input.Comparables != null &&
                    this.Comparables.SequenceEqual(input.Comparables)
                ) && 
                (
                    this.GeneratedAt == input.GeneratedAt ||
                    (this.GeneratedAt != null &&
                    this.GeneratedAt.Equals(input.GeneratedAt))
                ) && 
                (
                    this.Id == input.Id ||
                    this.Id.Equals(input.Id)
                ) && 
                (
                    this.Interval == input.Interval ||
                    (this.Interval != null &&
                    this.Interval.Equals(input.Interval))
                ) && 
                (
                    this.ReportPeriod == input.ReportPeriod ||
                    (this.ReportPeriod != null &&
                    this.ReportPeriod.Equals(input.ReportPeriod))
                ) && 
                (
                    this.UpdatedAt == input.UpdatedAt ||
                    (this.UpdatedAt != null &&
                    this.UpdatedAt.Equals(input.UpdatedAt))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.CompanyId != null)
                {
                    hashCode = (hashCode * 59) + this.CompanyId.GetHashCode();
                }
                if (this.Comparables != null)
                {
                    hashCode = (hashCode * 59) + this.Comparables.GetHashCode();
                }
                if (this.GeneratedAt != null)
                {
                    hashCode = (hashCode * 59) + this.GeneratedAt.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.Id.GetHashCode();
                if (this.Interval != null)
                {
                    hashCode = (hashCode * 59) + this.Interval.GetHashCode();
                }
                if (this.ReportPeriod != null)
                {
                    hashCode = (hashCode * 59) + this.ReportPeriod.GetHashCode();
                }
                if (this.UpdatedAt != null)
                {
                    hashCode = (hashCode * 59) + this.UpdatedAt.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
